require "vector"
require "camera"

function love.load()
	wx = 1024
	wy = 768
	camx = wx/2
	camy = wy/2
	
	world = love.physics.newWorld(wx, wy)
	world:setGravity(0, 400)
	world:setMeter(64)

	bodies = {}
	shapes = {}
  
	bodies[0] = love.physics.newBody(world, wx/2, 700, 0, 0)
	shapes[0] = love.physics.newRectangleShape(bodies[0], 0, 0, wx, 50, 0)
	
	bodies[1] = love.physics.newBody(world, wx/2, wy/2, 15, 5)
	shapes[1] = love.physics.newCircleShape(bodies[1], 0, 0, 20)
	
	bodies[2] = love.physics.newBody(world, 400, 400, 30, 150)
	shapes[2] = love.physics.newRectangleShape(bodies[2], 0, 0, 200, 20, 0)

	love.graphics.setBackgroundColor(0, 0, 0)
end

function love.update(dt)
	world:update(dt)
	cam = Camera(vector(camx,camy),1,0)
	
	if love.keyboard.isDown("right") then
		--bodies[1]:applyImpulse(4, 0)
		camx = camx+4
	elseif love.keyboard.isDown("left") then
		--bodies[1]:applyImpulse(-4, 0)
		camx = camx-4
	end
	
	if love.keyboard.isDown("up") then
		camy = camy-4
	elseif love.keyboard.isDown("down") then
		camy = camy+4
	end
	
	if love.keyboard.isDown("escape") then
		os.exit()
	end
	
	
	if love.keyboard.isDown("d") then
		bodies[2]:applyForce(0, -300, qx2, qy2)
	end
	if love.keyboard.isDown("a") then
		bodies[2]:applyForce(0, -300, qx1, qy1)
	end
	if love.keyboard.isDown("w") then
		bodies[2]:setY(650/2)
	end
	

end

function love.draw()
cam:predraw()

	local x1, y1, x2, y2, x3, y3, x4, y4 = shapes[0]:getBoundingBox()
	local boxwidth = x3 - x2
	local boxheight = y2 - y1
	love.graphics.setColor(255, 150, 50)
	love.graphics.rectangle("fill", bodies[0]:getX() - boxwidth/2, bodies[0]:getY() - boxheight/2, boxwidth, boxheight)
	love.graphics.setColor(50, 150, 255)
	love.graphics.circle("line", bodies[1]:getX(), bodies[1]:getY(), shapes[1]:getRadius(), 20)
	
	
	qx1, qy1, qx2, qy2, qx3, qy3, qx4, qy4 = shapes[2]:getPoints()
	qboxwidth = qx3 - qx2
	qboxheight = qy2 - qy1
	--love.graphics.rectangle("fill", bodies[2]:getX() - qboxwidth/2, bodies[2]:getY() - qboxheight/2, qboxwidth, qboxheight)
	love.graphics.line( qx1, qy1, qx2, qy2, qx3, qy3, qx4, qy4, qx1, qy1)
	

cam:postdraw()

	love.graphics.setColor(255, 255, 255)
	love.graphics.print("FPS: " .. love.timer.getFPS(), 50, 50)
	love.graphics.print("dt: " .. love.timer.getDelta(), 50, 70)
	love.graphics.print("Angle: " .. math.floor(math.deg(bodies[2]:getAngle())), 50, 90)
	love.graphics.print("qx1: " .. math.floor(qx1) .. " qy1: " .. math.floor(qy1) .. "\nqx2: " .. math.floor(qx2) .. " qy2: " .. math.floor(qy2) .. "\nqx3: " .. math.floor(qx3) .. " qy3: " .. math.floor(qy3) .. "\nqx4: " .. math.floor(qx4) .. " qy4: " .. math.floor(qy4), 50, 110)
end